<?php
/**
 * @package mod_sj_zoo_categories_ii
 * @version $Id$
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2009-2011 YouTech Company. All Rights Reserved.
 * @author YouTech Company
 *
 */

defined('_YTOOLS') or die;

if (!class_exists('ZooCategoriesIIReader')){
	class ZooCategoriesIIReader extends SjReader{
		protected $categories = null;
		protected $items = null;
		public  $db	;//= 	JFactory::getDBO();
		
		public function __construct(){
			
		}
		
		public function getRootCategories($catIds, $params){
			$categories = array();
			
			$query = "
				SELECT c.id, c.name as title, c.alias, c.description
				FROM #__zoo_category c
				WHERE
					c.application_id = $params->zoo_app
					AND c.published = 1
					AND c.id IN ($catIds)
				ORDER BY ordering
			";
			
			$this->db->setQuery($query);
			$rows = $this->db->loadObjectList();

			// // prepare for image resize.
			$imgResizeConfig = array(
				'background' => $params->item_thumbnail_background,
				'thumbnail_mode' => $params->item_thumbnail_mode
			);
			YtUtils::getImageResizerHelper($imgResizeConfig);
			foreach($rows as $category){
				
				$categories[$category->id] = $category;
				
				// category url
				$category->url = JRoute::_( 'index.php?option=com_zoo&task=category&category_id=' . $category->id );
				
				// category title truncate
				$category->title 		= YTools::truncate($category->title, $params->title_max_chars);

				$category->image_urls 	= YTools::extractImages($category->description);
				$category->description	= strip_tags($category->description);
				if ('none' == $params->item_thumbnail_mode){
					$category->image = empty($category->image_urls) ? 
											JURI::base().'modules/mod_sj_zoo_categories_ii/assets/images/nophoto.gif' : 
											$category->image_urls[0];
				} else {
					$category->image = empty($category->image_urls) ? 
											// JURI::base().'modules/mod_sj_zoo_categories_ii/assets/images/nophoto.gif' : 
											false :
											$category->image_urls[0];
					if (false != $category->image){
						$imagefile 			= JPath::find(JPATH_SITE, $category->image);
						$category->image 	= YtUtils::resize($imagefile, $params->item_thumbnail_width, $params->item_thumbnail_height, $params->item_thumbnail_mode);
					}
					
					if (! $category->image){
						$category->image	= JURI::base().'modules/mod_sj_zoo_categories_ii/assets/images/nophoto.gif';
					}
				}
			}
			
			return $categories;
		}
		
		public function getChildCategories($catId,$titleMax,$app){
			$categories = array();
			
			$query = "
				SELECT c.id, c.name as title, c.alias, c.description
				FROM #__zoo_category c
				WHERE
					c.application_id = $app
					AND c.published = 1
					AND c.parent = $catId
			";
			
			$this->db->setQuery($query);
			$rows = $this->db->loadObjectList();
			
			
			foreach($rows as $category){
				$categories[$category->id] = $category;
				
				// // category url
				// $slug = $category->alias ? $category->id.':'.$category->alias : $category->id;
				// $category->url = JRoute::_( ContentHelperRoute::getCategoryRoute($slug) );
				$category->url = JRoute::_( 'index.php?option=com_zoo&task=category&category_id=' . $category->id );
				// category title truncate
				$category->title = YTools::truncate($category->title, $titleMax);
			}
			
			return $categories;
		}
		
		public function getList(&$params){
			$this->db   		=&	JFactory::getDBO();
			
			// $categories = array();
			
			// $child_category_ids = array();
			
			// $user 		=&	JFactory::getUser();
			// $app 		=&	JFactory::getApplication();
			// $db   		=&	JFactory::getDBO();
			// $jnow		=& 	JFactory::getDate();
			// $now		= 	$jnow->toMySQL();
			// $nullDate	=	$db->getNullDate();
			// $noauth		= !	$app->getParams()->get('show_noauth');
			
			
			$params = (object)$params;
		
			// $params->source must be an array of IDs
			if (!isset($params->source) || empty($params->source)){
				$this->errors = "No selected or all selected is unpublished.";
				return array();
			}
			$category_ids = is_array($params->source) ? $params->source : array($params->source);
			$category_ids_sql = implode(',', $category_ids);
			
			
			//list result
			$list = $this->getRootCategories($category_ids_sql,$params);
			
			foreach ($list as $cid => $category){
				$listLev1	= $this->getChildCategories($cid, $params->title_max_chars,$params->zoo_app);
				foreach ($listLev1 as $cidLev1 => $categoryLev1){
					$listLev2	= $this->getChildCategories($cidLev1, $params->title_max_chars,$params->zoo_app);
					foreach ($listLev2 as $cidLev2 => $categoryLev2){
						$listLev3	= $this->getChildCategories($cidLev2, $params->title_max_chars,$params->zoo_app);
						
						$listLev2[$cidLev2]->childCat = $listLev3;
					}
					$listLev1[$cidLev1]->childCat = $listLev2;
				}
				$list[$cid]->childCat	= $listLev1;
			}
			
			return $list;
			
		}
	}
}