<?php
/**
 * @package Sj Categories II for Zoo
 * @version 1.1.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2014 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 *
 */
defined('_JEXEC') or die;

JHtml::stylesheet('modules/' . $module->module . '/assets/css/style.css');

if (!defined('SMART_JQUERY') && $params->get('include_jquery', 0) == "1") {
    JHtml::script('modules/' . $module->module . '/assets/js/jquery-1.8.2.min.js');
    JHtml::script('modules/' . $module->module . '/assets/js/jquery-noconflict.js');
    define('SMART_JQUERY', 1);
}

JHtml::script('modules/' . $module->module . '/assets/js/jsmart.changeImage.js');
JHtml::script('modules/' . $module->module . '/assets/js/jsmart.dimensions.js');
JHtml::script('modules/' . $module->module . '/assets/js/jsmart.accordion.js');
JHtml::script('modules/' . $module->module . '/assets/js/jsmart.tooltipmenu.js');

$options = $params->toObject();
$mod_width = intval($options->module_width);
$mod_style_width = $mod_width > 0 ? "style=\"width:{$mod_width}px;\"" : "";
$instance = rand() . time();

$widthLi = 170;
$rigthArrowWidth = 11;
$paddingLeftRight = 30;
$itemWidth = (int)(($options->module_width / $options->columns_max) - $paddingLeftRight);
$max_width_tooltip = $options->columns_max_level2 * $widthLi;
$addingItemWidth = $options->module_width - ($itemWidth + $paddingLeftRight) * $options->columns_max;

$navigator = JBrowser::getInstance();
$browser = $navigator->getBrowser();
$major = $navigator->getMajor();

ImageHelper::setDefault($params);
$big_image_config = array(
    'type' => $params->get('imgcfgcat_type'),
    'width' => $params->get('imgcfgcat_width'),
    'height' => $params->get('imgcfgcat_height'),
    'quality' => 90,
    'function' => ($params->get('imgcfgcat_function') == 'none') ? null : 'resize',
    'function_mode' => ($params->get('imgcfgcat_function') == 'none') ? null : substr($params->get('imgcfgcat_function'), 7),
    'transparency' => $params->get('imgcfgcat_transparency', 1) ? true : false,
    'background' => $params->get('imgcfgcat_background')
);

if ($options->theme == 'theme1') {
    JHtml::script('modules/' . $module->module . '/assets/js/jsmart.tooltipmenu.js');
    JHtml::stylesheet('modules/' . $module->module . '/assets/css/theme1.css');
    if ($browser == "msie" && $major == '7') {
        $script =
            '
            //<![CDATA[
            jQuery(document).ready(function($){
                $("#category_' . $instance . ' .theme1_root_list_child").tooltipMenu ({
						tooltipClass 		: ".tooltip_lev1",
						subTooltipClass 	: ".tooltip_lev2",
						addMarginLeft		: ' . $itemWidth . '
					});
				});
                //]]>
				';
    } else {

        $script =
            '
            //<![CDATA[
            jQuery(document).ready(function($){
                $("#category_' . $instance . ' .theme1_root_list_child").tooltipMenu({
						tooltipClass 		: ".tooltip_lev1",
						subTooltipClass 	: ".tooltip_lev2"
					});
				});
                //]]>
				';
    }
    $script = $script .
        '
        //<![CDATA[
            jQuery(document).ready(function($){
                $("#category_' . $instance . ' .theme1_root_list_child").MoreClick({

                    });
			    });
                //]]>
			';
}
if ($options->theme == 'theme2') {

    JHtml::script('modules/' . $module->module . '/asset/js/jsmart.dimensions.js');
    JHtml::script('modules/' . $module->module . '/asset/js/jsmart.accordion.js');

    if ($browser == "msie" && $major == '7') {
        JHtml::stylesheet('modules/' . $module->module . '/assets/css/theme2_msie_7.css');
    } else {
        JHtml::stylesheet('modules/' . $module->module . '/assets/css/theme2.css');
    }
    $script =
        '
            //<![CDATA[

                jQuery(document).ready(function($){
                $("#theme2_menu_category_' . $instance . '").accordion({
					header: ".theme2_title_root",
					alwaysOpen: true,
					autoheight: false,
					event: "mouseover"
				});
			});
            //]]>
		';
}

if ($options->theme == 'theme3') {
    JHtml::stylesheet('modules/' . $module->module . '/assets/css/theme3.css');
    $script =
        '
            //<![CDATA[
                jQuery(document).ready(function($){
                $("#categories_theme3_' . $instance . '").changeImage({});
			});
            //]]>
		';
}

if ($options->theme == 'theme4') {
    if ($browser == "msie" && $major == '7') {
        JHtml::stylesheet('modules/' . $module->module . '/assets/css/theme4_msie_7.css');
    } else {
        JHtml::stylesheet('modules/' . $module->module . '/assets/css/theme4.css');
    }
    $script = '';
}
$doc = JFactory::getDocument();
$doc->addScriptDeclaration($script);
?>
<?php if ($options->pretext != '') { ?>
    <div class="sj_introtext">
        <?php echo $options->pretext; ?>
    </div>
<?php } ?>


<?php if (!empty($list)) { ?>
    <div id="category_<?php echo $instance; ?>"
         style="border:1px solid #CCCCCC; width:<?php echo $options->module_width; ?>px;"
         class="sj_category <?php echo $options->theme; ?>">
        <?php require JModuleHelper::getLayoutPath($module->module, $options->theme); ?>
    </div>
<?php } else { ?>
    <p><?php echo JText::_('Has no content to show!'); ?></p>
<?php } ?>

<?php if ($options->posttext != '') { ?>
    <div class="sj_footertext">
        <?php echo $options->posttext; ?>
    </div>
<?php } ?>